#include <stdio.h>

#include "parsing.h"
#include "response.h"
#include "scan.h"

void print_usage(void)
{
	// TODO
}

static void print_port_state(const struct response *response, e_scantype type)
{
	if (type != SCAN_ALL && response->states[type] == CLOSED)
		return;
	printf("%-5d %-12s ", response->port,
	       response->service ? response->service : "Unassigned");
	if (type == SCAN_ALL)
		for (e_scantype i = SCAN_NULL; i < SCAN_ALL; i++)
			printf("%s(%s) ", types_str[i],
			       states_str[response->states[i]]);
	else
		printf("%s(%s) ", types_str[type],
		       states_str[response->states[type]]);
	printf("\n");
}

void print_host_results(const char *ip_addr, const struct response *responses,
                        const struct option_lst *options, double scan_time)
{
	printf("Scan took %lf secs\n", scan_time);
	printf("IP address: %s\n", ip_addr);
	printf("Open ports:\n");
	uint16_t port_start = 1, port_end = 1024;
	parse_ports(get_option_arg(options, FL_PORTS), &port_start, &port_end);
	e_scantype type = parse_type(get_option_arg(options, FL_SCAN));
	for (uint16_t i = port_start; i < port_end - port_start; i++) {
		print_port_state(&responses[i], type);
	}
}
